# FE-EntryTask-Blackcat

Front End Entry task for Shopee. Single page application (SPA) for a social event sharing platform called Blackcat.

### Checklist
---
#### **Core**
- [x] Gitlab Repo
- [ ] ~~Design and Document API~~
- [x] Use SCSS as preprocessor
- [x] Use CSS Modules with your React component
- [x] Use React 16+
- [x] Use `redux`
- [x] Use `redux-thunk`

#### **Optional**
- [ ] Setup Gitlab CI for testing and linting
- [ ] ~~implement session logic on backend express server~~
- [ ] CSS coding splitting
- [ ] Polyfills to save bundle size
- [ ] Add autoPrefixer
- [x] Explore new APIs, i.e. hooks, suspense
- [ ] Should have separate configurations for local development and production build.
- [ ] Support inject reducer asynchronously on demand instead of combine all the reducers up front
- [x] Create your own mock data using faker.js. and serve your fake data using a simple express.js service
- [x] Setup ESLint as a `pre-commit` hook
- [x] Use `prettier` to format your code automatically
- [x] Use `stylelint` as a `pre-commit` hook to lint your CSS code as well
- [ ] Set up `jest` and `enzyme` as your test framework
- [ ] Write at least one snapshot test
- [ ] Use enzyme to test out the rendering logic for at least one React component
- [ ] Support internationalisation (i18n)
- [ ] Support server side rendering
- [ ] Annotate page properly with SEO meta tags

### Setup Guide
This project was bootstrapped with [Create React App](https://github.com/facebook/create-react-app).

## Available Scripts

In the project directory, you can run:

### `npm start`

Runs the app in the development mode.<br />
Open [http://localhost:3000](http://localhost:3000) to view it in the browser.

The page will reload if you make edits.<br />
You will also see any lint errors in the console.

### `npm test`

Launches the test runner in the interactive watch mode.<br />
See the section about [running tests](https://facebook.github.io/create-react-app/docs/running-tests) for more information.

### `npm run build`

Builds the app for production to the `build` folder.<br />
It correctly bundles React in production mode and optimizes the build for the best performance.

The build is minified and the filenames include the hashes.<br />
Your app is ready to be deployed!

See the section about [deployment](https://facebook.github.io/create-react-app/docs/deployment) for more information.

### `npm run eject`

**Note: this is a one-way operation. Once you `eject`, you can’t go back!**

If you aren’t satisfied with the build tool and configuration choices, you can `eject` at any time. This command will remove the single build dependency from your project.

Instead, it will copy all the configuration files and the transitive dependencies (webpack, Babel, ESLint, etc) right into your project so you have full control over them. All of the commands except `eject` will still work, but they will point to the copied scripts so you can tweak them. At this point you’re on your own.

You don’t have to ever use `eject`. The curated feature set is suitable for small and middle deployments, and you shouldn’t feel obligated to use this feature. However we understand that this tool wouldn’t be useful if you couldn’t customize it when you are ready for it.

## Learn More

You can learn more in the [Create React App documentation](https://facebook.github.io/create-react-app/docs/getting-started).

To learn React, check out the [React documentation](https://reactjs.org/).